config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Login/Register
  devise_for :users, controllers: {
    sessions: 'users/sessions',
    registrations: 'users/registrations'
  }

  # Root
  root to: 'home#index'

  # Patient pages
  get 'patient/home', to: 'patients#home'
  get 'patient/:id', to: 'patients#show'

  # Doctors pages
  get 'doctor/home', to: 'doctors#home'
  get 'doctor/:id', to: 'doctors#show'

  get 'doctors', to: 'doctors#index', as: :doctor_search

  # Appointments
  post 'appointment/:id/close', to: 'appointments#close', as: :close_appointment

  get 'doctor/:doctor_id/appointments/new', to: 'appointments#new', as: :new_appointment
  post 'doctor/:doctor_id/appointments/create', to: 'appointments#create', as: :create_appointment

  # Admin
  ActiveAdmin.routes(self)
end

app/models/appointment.rb
# frozen_string_literal: true

# == Schema Information
#
# Table name: appointments
#
#  id          :bigint           not null, primary key
#  description :text
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#  doctor_id   :integer          not null
#  patient_id  :integer          not null
#
class Appointment < ApplicationRecord
  belongs_to :patient, foreign_key: :patient_id
  belongs_to :doctor, foreign_key: :doctor_id

  has_one :recommendation, dependent: :destroy

  validates :doctor, presence: true
  validates :patient, presence: true
  validates_associated :doctor

  after_validation :doctor_appointments_limit

  scope :closed, -> { joins(:recommendation) }
  scope :open, -> { where.not(id: closed) }

  def closed?
    recommendation.present?
  end

  def open?
    !closed?
  end

  def to_s
    description
  end

  private

  def doctor_appointments_limit
    return unless doctor

    errors.add(:doctor, 'Too many appointments') if doctor.appointments_full?
  end
end

app/controllers/appointments_controller.rb
# frozen_string_literal: true

class AppointmentsController < ApplicationController
  def close
    appointment = Appointment.find(params.dig(:recommendation, :appointment_id))

    authorize! :close, appointment
    Recommendation.create!(permitted_recommendation_params)
    redirect_back(fallback_location: root_path)
  end

  def new
    @doctor = Doctor.find(params[:doctor_id])
    @patient = current_user
    @appointment = Appointment.new(doctor: @doctor, patient: @patient)

    authorize! :create, @appointment
  end

  def create
    @doctor = Doctor.find(params[:doctor_id])
    appointment = Appointment.new(permitted_appointment_params)

    authorize! :create, appointment

    appointment.save!
    redirect_to patient_home_path
  end

  private

  def permitted_appointment_params
    return {} unless params.key?(:appointment)

    params[:appointment].permit(:description, :doctor_id, :patient_id)
                        .with_defaults(doctor_id: @doctor.id, patient_id: current_user.id)
  end

  def permitted_recommendation_params
    return {} unless params.key?(:recommendation)

    params[:recommendation].permit(:content, :appointment_id)
  end
end

app/views/appointments/_item.html.erb
<div class='appointment card'>
  <div class="info">
    <div class="patient">
      <span class="name">
        Patinet name: <%= item.patient.full_name %>
      </span>
      <% if can? :read_number, item.patient %>
        <span class="phone_number">
          <%= item.patient.phone_number %>
        </span>
      <% end %>
    </div>
    <hr/>
    <div class="doctor">
      <span class="name">
        Dr. <%= item.doctor.full_name %> 
      </span>
      <span class="doctor_category_name">
      <% if item.doctor.doctor_category %>
        <%= item.doctor.doctor_category.name %>
      <% end %>
      </span>
      <span class="phone_number">
        <% if can? :read_number, item.doctor %>
          <%= item.doctor.phone_number %>
        <% end %>
      </span>
    </div>
    <div class="text description">
      <p class="purpose">Appointment reason:</p>
      <%= item.description %>
    </div>
  </div>
  <% if item.open? && can?(:close, item) # if allowed to close appointments / create recommendations %>
    <%# <div class="close_form"> %>
    <%= form_with model: Recommendation.new(appointment: item), class: 'close_form', url: close_appointment_path(item), method: :post do |form| %>
      <%= form.hidden_field :appointment_id %>
      <%= form.text_field :content, placeholder: 'Response to the patient' %>
      <%= form.submit value: 'Give Recommendation' %>
    <% end %>
  <% end %>
</div>

app/views/appointments/new.html.erb
<div class="create_appointment card">
  <div class="doctor_name">DOCTOR: Dr. <%= @doctor.full_name %></div>
  <div class="patient_name">PATIENT: <%= @patient.full_name %></div>
</div>

<%= form_with model: @appointment, class: 'appointment_form', url: create_appointment_path(@doctor), method: :post do |form| %>
  <%= form.hidden_field :patient_id %>
  <%= form.hidden_field :doctor_id %>
  <%= form.text_field :description, placeholder: 'Reason to see the doctor' %>
  <%= form.submit %>
<% end %>